<?php
/**
 * Copyright 1999 - 2004 by Gero Kohnert
 *
 *  CVS Info:  $Id: bug_overview.php,v 1.15.2.1 2004/07/26 19:55:02 gokohnert Exp $
 *  $Author: gokohnert $
 *
 * Bugtracking module
 *
 * @modulegroup bug
 * @module bug_overview
 * @package bug
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'product.pinc';
 include_once 'timetrack.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("bugtracking","overview");
 loadmodule("bugtracking");
 loadlayout();

 /**
  * show a overview of bugs
  */
 class bug_overview extends layout {
   /**
    * display the info
    */
   Function info() {
     global $lang,$tutos;

     if ( $this->format == "xml") {
       echo $this->blist[0]->exportXMLHeader();
       echo $this->blist[0]->exportXML_Head();
       echo "<bug_set>\n";
       foreach ($this->blist as $i => $b) {        
         echo $b->exportXML_start();
         echo $b->exportXML_body();
         echo $b->exportXML_end();
       } 
       echo "</bug_set>\n";
       return;
     } else if ($this->format == "excel") {
       include_once '../../libs/excel/Worksheet.php';
       include_once '../../libs/excel/Workbook.php';

       header("Content-type: application/vnd.ms-excel");
       header("Content-Disposition: attachment; filename=BugExport.xls");
       header("Expires: 0");
       header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
       header("Pragma: public");

       $tmpname = tempnam ($tutos[sessionpath], "bugexport");
       $workbook = new Workbook($tmpname);
       $worksheet1 =& $workbook->add_worksheet('TUTOS');
	   $worksheet1->set_landscape();
	   $worksheet1->set_header($this->name);
	   $worksheet1->set_footer("TUTOS");


       $format1 =& $workbook->add_format();
       $format1->set_size(10);
       $format1->set_bold(1);
       $format1->set_fg_color('grey');
       $format1->set_bg_color('green');
       $format1->set_align('center');

       $format2 =& $workbook->add_format();
       $format2->set_size(8);

	   $x = 1;
       $c = 0;
       $worksheet1->set_column($c,$c,30,$format1);
       $worksheet1->write_string($x,$c++, $lang['BugID'],$format1);

       $worksheet1->set_column($c,$c,20);
       $worksheet1->write_string($x,$c++, $lang['BugState'],$format1);

       $worksheet1->set_column($c,$c,20);
       $worksheet1->write_string($x,$c++, $lang['BugClass'],$format1);

       $worksheet1->set_column($c,$c,20,$format2); # Date
       $worksheet1->write_string($x,$c++, $lang['Date'],$format1);

       $worksheet1->set_column($c,$c,30); # Project
       $worksheet1->write_string($x,$c++, $lang['BugReference'],$format1);

       $worksheet1->set_column($c,$c,50); # short
       $worksheet1->write_string($x,$c++, $lang['BugShort'],$format1);

       $worksheet1->set_column($c,$c,60); # long
       $worksheet1->write_string($x,$c++, $lang['BugLong'],$format1);

       $worksheet1->set_column($c,$c,20); # Solver
       $worksheet1->write_string($x,$c++, $lang['BugAssignedTo'],$format1);

	   $x = 2;
       foreach ($this->blist as $i => $z) {
         $b = &$this->blist[$i];
		 $c = 0;
         $worksheet1->write_string($x,$c++, $b->name);
         $worksheet1->write_string($x,$c++, $lang['BugStates'][$b->state],$format2);
         $worksheet1->write_string($x,$c++, $lang['BugClasses'][$b->class],$format2);
         $worksheet1->write_string($x,$c++, $b->creation->getDate());

         if ( $b->parent->id > 0 ) {
           $worksheet1->write_string($x,$c++, $b->parent->getFullName(),$format2);
         } else {
           $worksheet1->write_string($x,$c++,$lang['HistoryDeleted'],$format2);
         }
         $worksheet1->write_string($x,$c++, $b->short,$format2);
  	     if (count($b->bughist) > 0) {
           $worksheet1->write_string($x,$c++,$b->bughist[0]->description,$format2);
		 } else {
		   $c++;
		 }
  	     if ($b->solver->id > 0) {
           $worksheet1->write_string($x,$c++, $b->solver->getShortname(),$format2);
         } else {
           $worksheet1->write_string($x,$c++,$lang['HistoryDeleted'],$format2);
         }
		 $x++;
		 unset($b);
	   }

       $workbook->close();
       $fh = fopen($tmpname, "rb");
       if ($fh == false) {
         die("Can't read temporary file.");
       }
       fpassthru($fh);
       fclose($fh);
       @unlink($tmpname);
       return;		
     } else if ( $this->format == "stat") {
       $this->statinfo();
       return;
     }

  
     $n = count($this->blist);
     if ( 0 == $n) {
       echo $this->error($lang['Err0048']);
       return;
     }

     echo $this->actionformStart("bug_overview.php");
     echo $this->OverviewTableStart();
     echo "<thead>\n";
     echo "<tr>\n";
     echo $this->orderHeader("",$lang['BugID'],$this->link2);
     echo $this->orderHeader("creation",$lang['Date'],$this->link2);
     echo $this->orderHeader("",$lang['BugReference'],$this->link2);
     echo $this->orderHeader("",$lang['BugShort'],$this->link2);
     echo $this->orderHeader("state",$lang['BugState'],$this->link2);
     echo $this->orderHeader("class",$lang['BugClass'],$this->link2);
     echo $this->orderHeader("",$lang['BugCreator'],$this->link2);
     echo $this->orderHeader("",$lang['BugAssignedTo'],$this->link2);
     if ( $tutos[massupdate] == 1 ) {
       echo "  <th nowrap=\"nowrap\"><input type=\"checkbox\" name=\"checkit\" onclick=\"CheckAll2();\" /></th>\n";
     }
     echo "</tr>\n";
     echo "</thead>\n";

     if ( $this->format == "paper" ) {
       $a = 0;
       $end = $n;
     } else if ( $this->start == -1 ) {
       $a = $n - $tutos[maxshow];
       $end = $n;
       $this->start = $a;
     } else {
       $a = $this->start;
       $end = $this->start + $tutos[maxshow];
     }

     $this->filter['name'] = prepare_regpattern($this->filter['name']);

     $line = 0;
     while ( ($a < $n) && ($a < $end) ) {
       $b = &$this->blist[$a];

       echo $this->OverviewRowStart($line,$lang[$b->getType()] .": ". $b->getFullName());
       $x = myentities($b->getFullName());
       if ( $this->filter['name'] != "" ) {
         $x = eregi_replace("(". $this->filter['name'] .")","<span class=\"found\">\\1</span>",$x);
       }
       echo " <td nowrap=\"nowrap\" align=\"right\">". makelink($b->getUrl(),$x) ."</td>\n";
       echo " <td>". $b->creation->getDate() ."</td>\n";
       if ( $b->parent->id > 0 ) {
         echo " <td>&nbsp;". $b->parent->getLink() ."</td>\n";
       } else {
         echo " <td>&nbsp;". $lang['HistoryDeleted'] ."</td>\n";
       }
       $x = myentities($b->short);
       if ( $this->filter['name'] != "" ) {
         $x = eregi_replace("(". $this->filter['name'] .")","<span class=\"found\">\\1</span>",$x);
       }
       echo " <td>&nbsp;". $x ."</td>\n";
       echo " <td>&nbsp;". $b->getState() ."</td>\n";
       echo " <td>&nbsp;". $b->getClass() ."</td>\n";
	   if ($b->creator->id > 0) {
         echo " <td>&nbsp;". $b->creator->getLink($b->creator->getShortname()) ."</td>\n";
       } else {
         echo " <td>&nbsp;<i>". $lang['HistoryDeleted'] ."</i></td>\n";
       }
	   if ($b->solver->id > 0) {
         echo " <td>&nbsp;". $b->solver->getLink($b->solver->getShortname()) ."</td>\n";
       } else {
         echo " <td>&nbsp;<i>". $lang['HistoryDeleted'] ."</i></td>\n";
       }
       if ( $tutos[massupdate] == 1 ) {
         echo " <td align=\"center\">\n";
         if ( $b->mod_ok() ) {
           echo "<input name=\"mark[]\" type=\"checkbox\" value=\"". $b->id ."\" />\n";
         } else {
           echo "-\n";
         }
         echo "</td>\n";
       }
       echo $this->OverviewRowEnd($line++);
       $a++;
     }

     echo $this->list_navigation($this->link1,8 + $tutos[massupdate] ,$this->start,$a,$n);

     if ( $tutos[massupdate] == 1 ) {
       echo $this->UpdateRowStart(7);
       echo sprintf($lang['withmarked'],$lang['Bugs']);
       echo "&nbsp;<select name=\"action\">\n";
       echo " <option value=\"-1\" selected=\"selected\">". $lang['ActionNil'] ."</option>\n";
       if ( $tutos[bugdelete] == 1 ) {
         echo " <option value=\"-2\">". $lang['Delete'] ."</option>\n";
       }
       foreach ( $lang['BugClasses'] as $f => $i )  {
         echo " <option value=\"C". $f ."\">". sprintf($lang['SetTo'],$lang['BugClass'],$i) ."</option>\n";
       }
       foreach ( $lang['BugStates'] as $f => $i )  {
         echo " <option value=\"S". $f ."\">". sprintf($lang['SetTo'],$lang['BugState'],$i) ."</option>\n";
       }
       echo " <option value=\"-4\">". $lang['AclModify'] ."</option>\n";
       if (class_exists('watchlist')) {
         echo " <option value=\"WatchAdd\">". $lang['WatchAdd'] ."</option>\n";
         echo " <option value=\"WatchDel\">". $lang['WatchDel'] ."</option>\n";
       }
       echo "</select>\n";
       echo $this->UpdateRowEnd(2);
     }
     echo $this->OverviewTableEnd();
     echo $this->actionformEnd("bug_overview.php");
   }
   /**
    * Statistical Bug Info
    */
   Function statinfo() {
     global $lang,$tutos;

     $n = count($this->blist);
     $a = 0;

     $cmin = time();
     $cmax = -1;
     $tmin = time();
     $tmax = -1;
     $ttl = 0.0;
     $tts = 0.0;
     $ttc = 0.0;
     $ns = 0;
     $nc = 0;

     $cnt = 0;
     while ( $a < $n ) {
       $b = &$this->blist[$a];
       $a++;

       if ( ! $b->see_ok() ) {
         unset($b);
         continue;
       }
       if ( !isset($states[$b->state]) ) {
         $states[$b->state] = 0;
       }
       if ( !isset($classes[$b->class]) ) {
         $classes[$b->class] = 0;
       }
       $states[$b->state]++;
       $classes[$b->class]++;
       $t1 = $b->creation->getTimestamp();
       $cmin = min($t1,$cmin);
       $tmin = min($t1,$tmin);
       $cmax = max($t1,$cmax);
       $tmax = max($t1,$tmax);

       if ( ($b->state == BUG_STATE_SOLVED) && ($b->solvedate->notime != 1) ) {
         $t2 = $b->solvedate->getTimestamp();
         $tts += ( $t2 - $t1 );
         $tmax = max($t2,$tmax);
         $ns++;
       } else if ( ($b->state == BUG_STATE_CLOSED) && ($b->solvedate->notime != 1)) {
         $t2 = $b->solvedate->getTimestamp();
         $ttc += ( $t2 - $t1 );
         $tmax = max($t2,$tmax);
         $nc++;
       } else {
         $t2 = time();
       }
       $ttl += ( $t2 - $t1 );
       $bl[] = &$b;
       $cnt++;
       unset($b);
     }

     # we need it 
     $b = new bug($this->dbconn);

     echo $this->DataTableStart();
     echo "<tr>\n";
     echo " <th colspan=\"5\">". $lang['BugStatsTitle'] ."</th>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfield($lang['Count']);
     echo " <td colspan=\"4\">". $cnt ."\n";
     $pre = "filterd by ";
     while ( list ($i,$f) = @each ($this->filter) ) {
       if ( $i == 'state' ) {
         echo $pre . $lang['BugState'];
         if ( $f == -2 ) {
           echo " ". $lang['BugAnyButClosed'];
         } else {
           echo " ". $lang['BugStates'][$f];
         }
       } else if ( $i == 'classes' ) {
         echo $pre . $lang['BugClass'];
         echo " ". $lang['BugClasses'][$f];
       } else if ( ($i == 'name') && ($f != "") ) {
         echo $pre . $lang['ProdDesc'];
         echo " ". $f;
       } else if ( $i == 'from' ) {
         echo $pre . $lang['DateTimeFrom'];
         echo " ". $f->getDateTime();
       } else if ( $i == 'to' ) {
         echo $pre . $lang['DateTimeTill'];
         echo " ". $f->getDateTime();
       } else if ( $i == 'parent' ) {
         $p = getObject($this->dbconn,$f);
         echo $pre . $lang[$p->getType()];
         echo " ". $p->getLink();
       } else if ( $f != "" ) {
         echo $pre . $i;
         echo " ". $f;
       }
       $pre = " and ";
     }

     echo " </td>\n";
     echo "</tr>\n";

     # Creation Times
     $c1 = new DateTime();
     $c2 = new DateTime();
     $t1 = new DateTime();
     $t2 = new DateTime();
     $c1->setDateTimeTS($cmin);
     $c2->setDateTimeTS($cmax);
     $t1->setDateTimeTS($tmin);
     $t2->setDateTimeTS($tmax);
     echo "<tr>\n";
     echo $this->showfield($lang['BugBetween']);
     echo " <td colspan=\"2\">". $c1->getDateTime() ."</td>\n";
     echo " <td colspan=\"2\">". $c2->getDateTime() ."</td>\n";
     echo "</tr>\n";

     # Average Times
     echo "<tr>\n";
     echo $this->showfield($lang['BugAverage']);
     echo " <td>". sprintf($lang['BugAvgEnd'],($ttl /$cnt)/3600) ."<br>\n";
     if ( $ns > 0 ) {
       echo sprintf($lang['BugAvgSolve'],($tts /$ns)/3600,$ns) ."<br>\n";
     }
     if ( $nc > 0 ) {
       echo " ". sprintf($lang['BugAvgClose'],($ttc /$nc)/3600,$nc) ."\n";
     }
     echo "</td></tr>\n";

     # State distribution
     $link = $tutos['base'] ."/php/graph_bars.php";
     $link = addSessionKey($link);
     $link = addUrlParameter($link,"type=pie");
     @reset($states);
     echo "<tr>\n";
     if ( !function_exists('ImageCreate') ) {
       echo " <td valign=\"top\" rowspan=\"". count($states) ."\"><b>". $lang['BugState'] ."</b></td>";
     } else {
       echo $this->showfield($lang['BugState']);
     }
     $c = 0;
     while ( list ($i,$f) = @each ($states) ) {
       $val = number_format($f * 100.0 / $cnt ,2);
       if ( !function_exists('ImageCreate') ) {
         echo " <td>". $lang['BugStates'][$i] ."</td>\n";
         echo " <td align=\"right\">". $f ."</td>\n";
         echo " <td align=\"right\">". $val ."%</td>\n";
         echo "</tr>\n";
       }
       $link = addUrlParameter($link,"f[". $c ."]=".$val);
       $link = addUrlParameter($link,"t0[". $c ."]=". UrlEncode($lang['BugStates'][$i]));
       $link = addUrlParameter($link,"t1[". $c ."]=". $f );
       $link = addUrlParameter($link,"col[". $c ."]=". UrlEncode($b->c_state[$i]));
       $c++;
     }
     if ( function_exists('ImageCreate') ) {
       echo " <td colspan=\"4\" valign=\"top\"><img src=\"". $link ."\"></td>";
       echo "</tr>\n";
     }

     echo "<tr>\n";
     echo " <td>&nbsp;</td>\n";
     echo " <td colspan=\"4\">\n";
     echo " <table cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";
     echo " <tr>\n";
     echo "  <th align=\"left\">". $t1->getDateTime() ."</th>\n";
     echo " </tr>\n";
     @reset($bl);
     $h = 10;
     $w = 400;
     $xx = ($tmax - $tmin) / $w;
     if ( $xx > 0 ) {
       while ( list ($i,$b) = @each ($bl) ) {
         $x1 = $b->creation->getTimeStamp();
         if ( ($b->state == 3) || ($b->state == 4) ) {
           $x2 = $b->solvedate->getTimeStamp();
         } else {
           $x2 = time();
         }
         if ( $x2 > $tmax ) {
           $x2 = $tmax;
         }
         $part1 = number_format(($x1 - $tmin) / $xx);
         $part2 = number_format(($x2 - $x1) / $xx);
         $part3 = number_format(($tmax - $x2) / $xx);

         if ( $part2 < 1 ) {
           $part2 = 1;
         }
         if ( ($part1 + $part2 + $part3) < ($w + 1) ) {
           $part3 = $w + 1 - $part2 - $part1;
         }

         echo " <tr>\n";
         echo "<td width=\"". ($w +1) ."\">";
         if ( $part1 > 0 ) {
           $text = "<img border=\"0\" src=\"". $tutos['base'] ."/html/white.png\" width=\"". $part1 ."\" height=\"". $h ."\">";
           echo makelink($b->getURL(),$text,sprintf($lang['BugShow'],$b->getFullName()) );
         }
         $text = "<img border=\"0\" src=\"". $tutos['base'] ."/html/". $b->c_state[$b->state] .".png\" width=\"". $part2 ."\" height=\"". $h ."\">";
         echo makelink($b->getURL(),$text,sprintf($lang['BugShow'],$b->getFullName()) );

         if ( $part3 > 0 ) {
           $text = "<img border=\"0\" src=\"". $tutos['base'] ."/html/white.png\" width=\"". $part3 ."\" height=\"". $h ."\">";
           echo makelink($b->getURL(),$text,sprintf($lang['BugShow'],$b->getFullName()) );
         }
         echo "</td>\n";
         echo " </tr>\n";
       }
     }
     echo " <tr>\n";
     echo "  <th align=\"right\">". $t2->getDateTime() ."</th>\n";
     echo " </tr>\n";
     echo " </table>\n";
     echo " </td>\n";
     echo "</tr>\n";

     # Class distribution
     $b = new bug($this->dbconn);
     $link = $tutos['base'] ."/php/graph_bars.php";
     $link = addSessionKey($link);
     $link = addUrlParameter($link,"type=pie");
     @reset($classes);
     echo "<tr>\n";
     if ( !function_exists('ImageCreate') ) {
       echo " <td valign=\"top\" rowspan=\"". count($classes) ."\"><b>". $lang['BugClass'] ."</b></td>";
     } else {
       echo $this->showfield($lang['BugClass']);
     }
     $c = 0;
     while ( list ($i,$f) = @each ($classes) ) {
       $val = number_format($f * 100.0 / $cnt ,2);
       if ( !function_exists('ImageCreate') ) {
         echo " <td>". $lang['BugClasses'][$i] ."</td>\n";
         echo " <td align=\"right\">". $f ."</td>\n";
         echo " <td align=\"right\">". $val ."%</td>\n";
         echo "</tr>\n";
       }
       $link = addUrlParameter($link,"f[". $c ."]=".$val);
       $link = addUrlParameter($link,"t0[". $c ."]=". UrlEncode($lang['BugClasses'][$i]));
       $link = addUrlParameter($link,"t1[". $c ."]=". $f );
       $link = addUrlParameter($link,"col[". $c ."]=". UrlEncode($b->c_class[$i]));
       $c++;
     }
     if ( function_exists('ImageCreate') ) {
       echo " <td colspan=\"5\" valign=\"top\"><img src=\"". $link ."\"></td>";
       echo "</tr>\n";
     }

     echo $this->DataTableEnd();
   }
   /**
    * navigate
    */
   Function navigate() {
   }
   /**
    * action via massupdate
    */
   Function action() {
     global $lang,$msg;

     if ( $_GET['action'] == -2 ) {
       $this->dbconn->Begin("WORK");
       foreach ($_GET['mark'] as $key => $val) {
         $b = new bug($this->dbconn);
         $b = $b->read($val,$b);
         if ( $b->id != $val ) {
           continue;
         }
         if ( $b->del_ok() ) {
           $msg .= sprintf($lang['BugDeleteI'], $b->getFullName()) ."<br>";
           $msg .= $b->delete();
         } else {
           $msg .= $b->getLink() .": ". sprintf($lang['Err0023'],$lang[$b->getType()]) ."<br>\n";
         }
         unset($b);
       }
       $this->dbconn->Commit("WORK");
       return;
     }
     if ( $_GET['action'] == -4 ) {
       $this->redirect = "../". acl_action();
       return;
     }
     if ( ereg("^([SC])(.*)",$_GET['action'],$a) ) {
       # Setting State or Class

       $this->dbconn->Begin("WORK");
       foreach ($_GET['mark'] as $key => $val) {
         $b = new bug($this->dbconn);
         $b = $b->read($val,$b);
         if ( $b->id != $val ) {
           continue;
         }
         if ( $b->mod_ok() ) {
           if ( $a[1] == "S" ) {
             $msg .= $b->getLink() ." ". $lang['BugState'] ." = ". $lang['BugStates'][$a[2]] ."<br>";
             $b->setState($a[2]);
           } else if ( $a[1] == "C" ) {
             $msg .= $b->getLink() ." ". $lang['BugClass'] ." = ". $lang['BugClasses'][$a[2]] ."<br>";
             $b->setClass($a[2]);
           } else {
             $msg .= "A:".$_GET['action'] ." M: '". $val[1] ."'  V:". $val[2] ."<br>";
           }
           $msg .= $b->save();
         } else {
           $msg .= $b->getLink() .": ". sprintf($lang['Err0024'],$lang[$b->getType()])."<br>\n";
         }
         unset ($b);
       }
       $this->dbconn->Commit("WORK");
       return;
     }
     if (class_exists('watchlist')) {
       watchlist::parse_action($this->user);
     }
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang;

     if ( $this->format == "stat") {
       $this->name = $lang['BugStatsTitle'];
     } else {
       $this->name = $lang['BugsOverview'];
     }

     if ( ! $this->user->feature_ok(usebugtracking,PERM_SEE) ) {
       $msg .= sprintf($lang['Err0022'],"'". $this->name ."'");
       $this->stop = true;
     }

     $this->link1 = "bugtracking/bug_overview.php";
     $this->filter = array();

     $this->link1 = addUrlParameter($this->link1,"format=".UrlEncode($this->format));

     if ( isset($_GET['id']) ) {
       $id = $_GET['id'];
     }
     if ( isset($_GET['pid']) ) {
       $pid = $_GET['pid'];
     }
     if ( isset($_GET['solverid']) ) {
       $solverid = $_GET['solverid'];
     }
     if ( isset($_GET['state']) ) {
       $state = $_GET['state'];
     } else {
       $state = "";
     }
     if ( isset($_GET['class']) ) {
       $class = $_GET['class'];
     } else {
       $class = "";
     }
     if ( isset($_GET['name']) ) {
       $name = $_GET['name'];
     } else {
       $name = "";
     }
     $this->filter['name'] = "";

     $q1 = "SELECT * FROM ". $this->dbconn->prefix ."bugs";
     $q2 = "SELECT b.* FROM ". $this->dbconn->prefix ."bugs b ,". $this->dbconn->prefix ."bugchanges c WHERE b.id = c.bugid";

     $pre1 = " WHERE ";
     $pre2 = " AND ";

     if ( ($name != "*") && ($name != "") ) {
       $q1 .= " " . $pre1 ."(". $this->dbconn->Like("description",$name) ." OR ". $this->dbconn->Like("short",$name) ." OR ". $this->dbconn->Like("id",$name)." OR ". $this->dbconn->Like("name",$name) .")";
       $pre1 = " AND ";

       $q2 .= " " . $pre2 ."(". $this->dbconn->Like("c.description",$name) ." OR ". $this->dbconn->Like("b.short",$name) ." OR ". $this->dbconn->Like("b.id",$name)." OR ". $this->dbconn->Like("b.name",$name) .")";
       $pre2 = " AND ";


       $this->link1 = addUrlParameter($this->link1,"name=".UrlEncode($name));
       $this->addHidden("name",$name);
       $this->filter['name'] = $name;
     }

     if ( isset($id) ) {
       $q1 .= " ". $pre1 ." id = ".$id;
       $q2 .= " ". $pre2 ." b.id = ".$id;
       $pre1 = " AND ";
       $pre2 = " AND ";
       $this->link1 = addUrlParameter($this->link1,"id=". $id);
       $this->addHidden("id",$id);
     }
     # States to display
     if ( $state == -2 )  {
       $q1 .= " ". $pre1 ." state != ". BUG_STATE_SOLVED;
       $q2 .= " ". $pre2 ." b.state != ". BUG_STATE_SOLVED;
       $pre1 = " AND ";
       $this->link1 = addUrlParameter($this->link1,"state=". $state);
       # remember this
#       session_register('bugsearchstate');
       $_SESSION['bugsearchstate'] = $state;
       $this->filter['state'] = $state;
       $this->addHidden("state",$state);
     } else if ( $state > 0 )  {
       $q1 .= " ". $pre1 ." state=".$state;
       $q2 .= " ". $pre2 ." b.state=".$state;
       $pre1 = " AND ";
       $pre2 = " AND ";
       $this->link1 = addUrlParameter($this->link1,"state=". $state);
       # remember this
#       session_register('bugsearchstate');
       $_SESSION['bugsearchstate'] = $state;
       $this->filter['state'] = $state;
       $this->addHidden("state",$state);
     }
     # Classes to display
     if ( $class > 0 ) {
       $q1 .= " ". $pre1 ." class=". $class;
       $q2 .= " ". $pre2 ." b.class=". $class;
       $pre1 = " AND ";
       $pre2 = " AND ";
       $this->link1 = addUrlParameter($this->link1,"class=". $class);
       # remember this
#       session_register('bugsearchclass');
       $_SESSION['bugsearchclass'] = $class;
       $this->filter['classes'] = $class;
       $this->addHidden("class",$class);
     }
     # Parent to display
     if ( isset($pid) ) {
       $ref = getObject($this->dbconn,$pid);
       $this->name .= " : ".$ref->getFullName();
       $q1 .= $pre1 ." product_id in (". $pid;
       $q2 .= $pre2 ." b.product_id in (". $pid;
       $pre1 = " AND ";
       $pre2 = " AND ";

       $sep = ",";
       if ( isset($_GET['show']) && ($_GET['show'] == "all") ) {
		 loadmodule('installation');
         $this->link1 = addUrlParameter($this->link1,"show=". $_GET['show']);
         $this->addHidden("show",$_GET['show']);
         add_task_ids($ref,$q1,$sep);
         add_inst_ids($ref,$q1,$sep);
       }
       $q1 .= ")";
       $q2 .= ")";
       $this->link1 = addUrlParameter($this->link1,"pid=". $pid);
       $this->filter['parent'] = $pid;
       $this->addHidden("pid",$pid);
     }
     # Start Date for search
     $from = new DateTime(0);
     if ( isset($_GET['fd']) ) {
       $from->setDateTime($_GET['fd']);
     } else {
       $from->setDateTimeF("f");
       # remember this
#       session_register('bugsearchfrom');
       $_SESSION['bugsearchfrom'] = $from->getYYYYMMDD();
     }
     if ( $from->notime != 1 ) {
       $q1 .= $pre1 ."(creation >= ". $this->dbconn->Date($from) .")";
       $q2 .= $pre2 ."(b.creation >= ". $this->dbconn->Date($from) .")";
       $pre1 = " AND ";
       $pre2 = " AND ";
       $this->link1 = addUrlParameter($this->link1,"fd=".$from->getYYYYMMDD());
       $this->filter['from'] = $from;
       $this->addHidden("fd",$from->getYYYYMMDD());
     }
     # End Date for search
     $to = new DateTime(0);
     if ( isset($_GET['td']) ) {
       $to->setDateTime($_GET['td']);
     } else {
       $to->setDateTimeF("t");
       # remember this
#       session_register('bugsearchto');
       $_SESSION['bugsearchto'] = $to->getYYYYMMDD();
     }
     if ( $to->notime != 1 ) {
       $q1 .= $pre1 ."(creation <= ". $this->dbconn->Date($to) .")";
       $q2 .= $pre2 ."(b.creation <= ". $this->dbconn->Date($to) .")";
       $pre1 = " AND ";
       $pre2 = " AND ";
       $this->link1 = addUrlParameter($this->link1,"td=".$to->getYYYYMMDD());
       $this->filter['to'] = $to;
       $this->addHidden("td",$to->getYYYYMMDD());
     }

     # user to display
     if ( isset($solverid) ) {
       $q1 .= $pre1 ." solver = ". $solverid;
       $q2 .= $pre2 ." b.solver = ". $solverid;
       $pre1 = " AND ";
       $pre2 = " AND ";
       $this->link1 = addUrlParameter($this->link1,"solverid=". $solverid);
       $this->filter['solver'] = $solverid;
       $this->addHidden("solverid",$solverid);
     }

     check_dbacl( $q1, $this->user->id);

     # sorting
     $xxx = "";
     $this->link2 = $this->link1;
     order_parse($q1,$this->link1,$xxx,$hidden,"state,creation");

     $this->result1 = $this->dbconn->Exec($q1);
     $this->result2 = $this->dbconn->Exec($q2);

     $n1 = $this->result1->numrows();
     $n2 = $this->result2->numrows();

#	 echo "Q1:".$q1."<br>";
#	 echo "Q2:".$q2."<br>";
#	 echo "N1:".$n1."<br>";
#	 echo "N2:".$n2."<br>";
     # Make a big array of all visible bugs
     $this->blist = array();
     $h = array();
     $x = 0;
     while ( $x < $n1 ) {
       $b = new bug($this->dbconn);
       $b = $b->read($this->result1->get($x, "id"),$b);
       $x++;
       if ( ! $b->see_ok() ) {
         continue;
       }
	   if (! isset($h[$b->id]) ) {
         $this->blist[] = &$b;
		 $h[$b->id] = 1;
	   }
       unset($b);
     }
     $x = 0;
     while ( $x < $n2 ) {
       $b = new bug($this->dbconn);
       $b = $b->read($this->result2->get($x, "id"),$b);
       $x++;
       if ( ! $b->see_ok() ) {
         continue;
       }
	   if (! isset($h[$b->id]) ) {
         $this->blist[] = &$b;
		 $h[$b->id] = 1;
	   }
       unset($b);
     }

     $n = count($this->blist);
     $this->result1->free();
     $this->result2->free();



     if ( 0 == $n) {
       $this->redirect = "bug_select.php?msg=". UrlEncode($lang['Err0048']);
	   return;
     } else if ( ($this->format == "html") && ($n == 1) ) {
       $this->redirect =  "bug_show.php?id=".$this->blist[0]->id;
	   return;
     }



     # menu
     $x = bug::getSelectLink($this->user,$lang['Search']);
     $x[category][] = "obj";
     $this->addmenu($x);

     if ( $this->user->feature_ok(usebugtracking,PERM_NEW) ) {
       $x = array( url => "bugtracking/bug_new.php",
                   text => $lang['NewEntry'],
                   info => $lang['CreateNewBug'],
                   category => array("bug","new","obj")
                 );
       $this->addMenu($x);
     }

     if ( $this->format != "stat" ) {
       $l = addUrlParameter($this->link1,"format=paper");
       $x = array( url => $l,
                   image => $this->user->layout->theme->getImage(bug::getHtmlIcon(),'menu'),
                   text => $lang['Printable'],
                   info => $lang['PrintableInfo'],
                   category => array("view","bug")
                 );

       $this->addMenu($x);
       $l = addUrlParameter($this->link1,"format=stat");
       $x = array( url => $l,
                   image => $this->user->layout->theme->getImage(bug::getHtmlIcon(),'menu'),
                   text => $lang['BugStats'],
                   info => $lang['BugStatsInfo'],
                   category => array("view","bug")
                 );
       $this->addMenu($x);
     }
     $l = addUrlParameter($this->link1,"format=excel");
     $x = array( url => $l,
                 text => $lang['Export'] ."(EXCEL)",
                 info => $lang['ExportInfo'],
                 category => array("bug","view")
               );
     $this->addMenu($x);

     web_StackStartLayout($this,"bug_overview.php","bug_overview.php");
   }
 }

 $l = new bug_overview($current_user);
 $l->display();
 $dbconn->Close();
?>