<?php
/*
 * Copyright 1999 - 2004 by Gero Kohnert
 *
 * Help System
 */
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'appointment.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("help","show");
 loadlayout();


 /**
  * display
  */
 class tutos_help extends layout {
   /**
    *
    */
   Function load_lang_file($dir,$p) {
     global $current_user,$tutos,$lang;

     $dbconn = $this->dbconn;
     # try direct with language preset
     if ( isset($_GET['lg']) ) {
       echo "<!-- try: ". getcwd()."/". $dir."/".$p ."_". $_GET['lg'] .".html -->\n";
       if ( file_exists(getcwd()."/".$dir ."/". $p ."_". $_GET['lg'] .".html") ) {
         $this->filename = $dir."/".$p ."_". $_GET['lg'] .".html";
         include $this->filename;
         return true;
       }
     }
     # try direct with language of current_user
     if ( isset($current_user->lang) && ($current_user->lang != "auto") ) {
       echo "<!-- try: ". getcwd()."/". $dir."/".$p ."_". $current_user->lang .".html -->\n";
       if ( file_exists(getcwd()."/".$dir ."/". $p ."_". $current_user->lang .".html") ) {
         $this->filename = $dir."/".$p ."_". $current_user->lang .".html";
         include $this->filename;
         return true;
       }
     }

     # next try with preferred language of browser
     $langs = "";
     if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
       $langs = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
     }
     $tok = trim(strtok($langs,","));
     while($tok) {
       if ( strpos($tok,";") > 0) {
         $tok = substr($tok,0,strpos($tok,";"));
       }
       $tok = strtolower($tok);
       echo "<!--  try: ". getcwd()."/". $dir."/".$p ."_". $tok .".html -->\n";
       if ( file_exists(getcwd()."/".$dir ."/". $p ."_". $tok .".html") ) {
         $this->filename = $dir."/".$p ."_". $tok .".html";
         include $this->filename;
         return true;
       }
       $tok = trim(strtok(","));
     }

     # try direct
     echo "<!-- try: ". getcwd()."/". $dir."/".$p .".html -->\n";
     if ( file_exists(getcwd()."/".$dir ."/". $p .".html") ) {
       $this->filename = $dir."/".$p .".html";
       include $this->filename;
       return true;
     }

     return false;
   }
   /**
    * the data display part
    */
   Function info() {
     global $tutos;

     if ( $this->load_lang_file(".",$this->p) ) {
       return;
     } else if ( $this->load_lang_file("./help",$this->p) ) {
       return;
     } else if ( $this->load_lang_file($tutos['base'] ."/html/help",$this->p) ) {
       return;
     }
     foreach ($tutos[modules] as $r => $x) {
       if ( $this->load_lang_file(dirname($tutos['base'] ."/". $tutos[modules][$r][file]) ."/help",$this->p) ) {
         return;
       }
     }


     if ( $this->load_lang_file($tutos['base'] ."/html/help","index") ) {
       return;
     } else {
       echo "File ". $this->p ." not found";
     }
   }
   /**
    *
    */
   Function navigate() {
     global $lang, $tutos;

     echo "<tr><td nowrap>";
     if ( file_exists(getcwd()."/".$tutos['base'] ."/documentation/book0/user.html") ) {
       echo menulink($tutos['base'] ."/documentation/book0/user.html","Users Guide","Users Guide") ."<br>";
     }
     if ( $this->user->isAdmin()) {
       if ( file_exists(getcwd()."/".$tutos['base'] ."/documentation/book0/admin.html") ) {
         echo menulink($tutos['base'] ."/documentation/book0/admin.html","Admin Guide","Admin Guide") ."<br>";
       }
     }
     echo "</td></tr>";
   }
   /**
    *
    */
   Function prepare() {
     global $tutos,$lang;

     $this->name = $lang['Help'];
     if ( ! isset($_GET['p']) ) {
       $this->p = "index";
     } else {
       $this->p = $_GET['p'];
     }
     $x = array( url => "help.php?p=index",
                 text => "Index",
                 info => "Index",
                 target => "help",
                 category => array("view")
               );
     $this->addMenu($x);
     $x = array( url => "help.php?p=glossary",
                 text => "Glossar",
                 info => "Glossar",
                 target => "help",
                 category => array("view")
               );
     $this->addMenu($x);
     $x = array( url => "http://wiki.tutos.org",
                 text => "WIKI",
                 info => "WIKI",
                 target => "WIKI",
                 category => array("obj")
               );
     $this->addMenu($x);

     foreach ($tutos[modules] as $r => $x) {
       loadmodule($r);
     }

   }
 }

 $l = new tutos_help($current_user);
 $l->display();
 @$dbconn->Close();
?>
<!--
    CVS Info:  $Id: help.php,v 1.18.2.2 2004/09/04 13:02:46 gokohnert Exp $
    $Author: gokohnert $
-->
