<?php
/**
 * Copyright 2004 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup reminder
 * @module reminder_ins
 * @package reminder
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'permission.p3';
 include_once 'webelements.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('reminder','ins');
 loadmodule("reminder");

 $gotourl = "reminder/reminder_new.php";
 $msg = "";

 $obj = new reminder($dbconn);
 if ( isset($_POST['id']) ) {
   $obj = $obj->read($_POST['id'],$obj);
   $gotourl= addUrlParameter($gotourl,"id=". $obj->id,true);
 }

 if ( empty($_POST['link_id']) ) {
   $msg .= "No Link ID given !<br>";
 } else {
   $obj->setReference($_POST['link_id']);
   $gotourl= addUrlParameter($gotourl,"link_id=". $obj->link_id,true);
   $obj->read_reference();
 }

 if ( empty($_POST['to']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['ReminderTo']) ."<br>";
 } else {
   $obj->setTo($_POST['to']);
   $gotourl= addUrlParameter($gotourl,"to=". $obj->to,true);
 }

 if ( !empty($_POST['desc']) ) {
   $obj->setDescription(StripSlashes($_POST['desc']));
   $gotourl= addUrlParameter($gotourl,"desc=". UrlEncode($obj->desc),true);
 }

 if(isset($_POST['repeat'])) {
   $obj->setRepeat($_POST['repeat']);
   $gotourl= addUrlParameter($gotourl,"repeat=". UrlEncode($obj->repeat),true);
 } else {
   $obj->setRepeat(0);
 }

 $usemail = 0;
 if(isset($_POST['usemail'])) {
   $usemail = $_POST['usemail'];;
   $gotourl= addUrlParameter($gotourl,"usemail=". UrlEncode($usemail),true);
 }
 $obj->setUseMail($usemail);

 if(isset($_POST['usemail'])) {
   $obj->setOffset($_POST['offset']);
 } else {
   $obj->setOffset(0);
 }
 $r = new DateTime(0);
 if($_POST['type'] == 0) {
   $type = REMINDER_SIMPLE;
   $r->setDateTimeF("at");
   $gotourl= addUrlParameter($gotourl,"type=0",true);
 } else {
   $type = $_POST['rd_type'];
   $gotourl= addUrlParameter($gotourl,"type=1",true);
 }
 $gotourl= addUrlParameter($gotourl,"rd_type=". UrlEncode($type),true);
 $gotourl= addUrlParameter($gotourl,"offset=". UrlEncode($obj->offset),true);

 $obj->setType($type);
 $msg .= $obj->calc_date($r);
 $obj->setRemindDate($r);

 # other modules
 $msg .= module_parseforms($current_user,$b,$gotourl);

 if ( $msg == "" ) {
   $dbconn->Begin("WORK");
   $msg .= $obj->save();
   $dbconn->Commit("WORK");
   $gotourl =  $obj->getURL();
 }
 $gotourl = addMessage($gotourl,$msg,true);
 $gotourl = addSessionKey($gotourl,true);

 Header("Status: 302 Moved Temporarily");
 Header("Location:". dirname(getBaseUrl()) ."/". $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: reminder_ins.php,v 1.3.2.2 2004/07/26 19:55:05 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
