<?php
/**
 * Copyright 1999 - 2004 by Gero Kohnert
 *
 * @modulegroup team
 * @module team_overview
 * @package team
 */
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'appointment.pinc';
 include_once 'product.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("team","overview");
 loadlayout();

 /**
  * display an overview of teams
  */
 class team_overview extends layout {
   /**
    * the data display part
    */
   Function info() {
     global $tutos,$lang;


     $n = $this->result->numrows();


     # Make a big array of all visible teams
     $x = 0;
     while ( $x < $n ) {
       $b = new team($this->dbconn);
       $b->read_result($this->result,$x);
       $x++;
       if ( ! $b->see_ok() ) {
         unset($b);
         continue;
       }
       $tlist[] = &$b;
       unset($b);
     }
     $n = count($tlist);
     $this->result->free();
     if ( 0 == $n) {
       echo $this->error( $lang['Err0048'] );
       return;
     }


     echo $this->actionformStart("team_overview.php");
     echo $this->OverviewTableStart();
     echo "<thead>\n";
     echo "<tr>\n";
     echo $this->orderHeader("name",$lang['Team'],$this->link2);
     echo $this->orderHeader("",$lang['TeamManager'],$this->link2);
     echo $this->orderHeader("",$lang['TeamCount'],$this->link2);
     if ( $tutos[massupdate] == 1 ) {
       echo "  <th nowrap=\"nowrap\"><input type=\"checkbox\" name=\"checkit\" onclick=\"CheckAll2();\" /></th>\n";
     }
     echo "</tr>\n";
     echo "</thead>\n";

     if ( $this->start == -1 ) {
       $a = $n - $tutos[maxshow];
       $end = $n;
       $this->start = $a;
     } else {
       $a = $this->start;
       $end = $this->start + $tutos[maxshow];
     }

     $line = 0;
     while ( ($a < $n) && ($a < $end) ) {
       $t = $tlist[$a];

       echo $this->OverviewRowStart($line);
       echo " <td>". $t->getLink() ."</td>\n";
       if ($t->owner != -1) {
         echo " <td>". $t->owner->getLink() ."&nbsp;</td>\n";
       } else {
         echo " <td>&nbsp;</td>\n";
       }
       echo " <td align=\"right\">". count($t->ids) ."</td>\n";
       if ( $tutos[massupdate] == 1 ) {
         echo " <td align=\"center\">\n";
         if ( $t->mod_ok() ) {
           echo "<input name=\"mark[]\" type=\"checkbox\" value=\"". $t->id ."\" />\n";
         } else {
           echo "-\n";
         }
         echo "</td>\n";
       }
       echo $this->OverviewRowEnd($line++);
       $a++;
     }

     echo $this->list_navigation($this->link1,3 + $tutos[massupdate],$this->start,$a,$n);

     if ( $tutos[massupdate] == 1 ) {
       echo $this->UpdateRowStart(2);
       echo sprintf($lang['withmarked'],$lang['Teams']);
       echo "&nbsp;<select name=\"action\">\n";
       echo " <option value=\"-1\" selected=\"selected\">". $lang['ActionNil'] ."</option>\n";
       echo " <option value=\"-2\">". $lang['Delete'] ."</option>\n";
       echo " <option value=\"-4\">". $lang['AclModify'] ."</option>\n";
       if (class_exists('watchlist')) {
         echo " <option value=\"WatchAdd\">". $lang['WatchAdd'] ."</option>\n";
         echo " <option value=\"WatchDel\">". $lang['WatchDel'] ."</option>\n";
       }
       echo "</select>\n";
       echo $this->UpdateRowEnd(2);
     }

     echo $this->OverviewTableEnd();
     echo $this->actionformEnd("team_overview.php");
   }
   /**
    *
    */
   Function navigate() {
   }
   /**
    * do mass actions
    */
   Function action() {
     global $msg,$lang;

     if ( $_GET['action'] == -2 ) {
       $this->dbconn->Begin("WORK");
       foreach ($_GET['mark'] as $key => $val) {
         $obj = new team($this->dbconn);
         $obj = $obj->read($val,$obj);
         if ( $obj->id != $val ) {
           continue;
         }
         if ( $obj->del_ok() ) {
           $msg .= $lang['Delete'] ."&nbsp;". $obj->getFullName() ."<br />";
           $msg .= $obj->delete();
         } else {
           $msg .= $obj->getLink() .": ". sprintf($lang['Err0023'],$lang[$obj->getType()]) ."<br />";
         }
         unset($obj);
       }
       $this->dbconn->Commit("WORK");
       return;
     }
     if ( $_GET['action'] == -4 ) {
       $this->redirect = acl_action();
       return;
     }
     if (class_exists('watchlist')) {
       watchlist::parse_action($this->user);
     }
   }
   /**
    *
    */
   Function prepare() {
     global $lang;

     $this->name = $lang['TeamOverview'];

     $this->link1 = "team_overview.php";
     $this->q = "SELECT * FROM ". $this->dbconn->prefix ."teams";
     $pre = " WHERE ";

     if ( isset($_GET['name']) && ($_GET['name'] != "*") && ($_GET['name'] != "") ) {
       $this->q .= $pre .  $this->dbconn->Like("name",$_GET['name']);
      $pre = " AND ";
       $this->link1 = addUrlParameter($this->link1,"name=". UrlEncode($_GET['name']));
     }

     check_dbacl( $this->q, $this->user->id);

     # sorting
     $xxx = "";
     $this->link2 = $this->link1;
     order_parse($this->q,$this->link1,$xxx,$xxx,"name");
     # display default sortorder
     if (!isset($_GET['xf'])) {
       $_GET['xf'] = "name";
       $_GET['xo'] = 1;
     }

     # Menu      
     $x = team::getSelectLink($this->user,$lang['Search']);
     $this->addMenu($x);

     if ( $this->user->feature_ok(useteams,PERM_NEW) ) {
       $x = array( url => "team_new.php",
                   text => $lang['NewEntry'],
                   info => $lang['TeamCreateI'],
                   category => array("team","new","obj")
                 );
       $this->addMenu($x);
     }
     web_StackStartLayout($this,"team_overview.php","team_overview.php");

     $this->result = $this->dbconn->Exec($this->q);
     $n = $this->result->numrows();
     if ( 0 == $n) {
       $this->redirect = "team_select.php?msg=". UrlEncode($lang['Err0048']);
       $this->result->free();
     } else if ( ($this->format == "html") && ($this->result->numrows() == 1) ) {
       $b = new team($this->dbconn);
       $b->read_result($this->result,0);
       if ( $b->see_ok() ) {
         $this->redirect =  "team_show.php?id=".$b->id;
         $this->result->free();
       }
     }
   }
 }

 $l = new team_overview($current_user);
 $l->display();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: team_overview.php,v 1.50.2.1 2004/07/26 19:55:00 gokohnert Exp $
    $Author: gokohnert $
-->