<?php
/**
 * Copyright 1999 - 2004 by Gero Kohnert
 *
 * $Id: team_show.php,v 1.54.2.3 2004/09/01 15:24:09 gokohnert Exp $
 * $Author: gokohnert $
 *
 * @modulegroup team
 * @module team_show
 * @package team
 */
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'appointment.pinc';
 include_once 'product.pinc';
 include_once 'address_tools.p3';
 include_once 'pdf.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("team","show");
 loadlayout();

 function member_sort(&$a,&$b) {
   if ( ($a->gettype() == 'team') && ($b->gettype() != 'team') ) {
     return 1;
   }
   if ( ($b->gettype() == 'team') && ($a->gettype() != 'team') ) {
     return -1;
   }
   # both are the same type, so we can compare
   return ($a->getFullName() < $b->getFullName()) ? -1 : 1;
 }
 /**
  * display an overview of installations
  */
 class team_show extends layout {
   /**
    * display the info as PDF
    */
   Function pdf() {
     global $tutos,$lang;

     usort($this->obj->member,"member_sort");

     $pdf=new tutospdf($this->obj->dbconn);
     $pdf->Open();
     $pdf->setAuthor($this->obj->creator->getFullName());
     $pdf->setTitle($this->obj->getFullName());
     $pdf->setSubject($this->obj->getFullName());

	 $pdf->headtitle = $lang[$this->obj->getType()] .":". $this->obj->getFullName();
     $pdf->AddPage();

     $w  = array(35,25,40,50,0);
     $fs = array(7,7,7,7,7);
     $al = array('R','R','L','L','L');


     # Header
     $h = 8;
     $pdf->SetFont('Arial','B',$fs[0]);
     $pdf->Cell($w[0],$h, $lang['AdrName'],1,0,$al[0]);
     $pdf->SetFont('Arial','B',$fs[1]);
     $pdf->Cell($w[1],$h, $lang['Description'],1,0,$al[1]);
     $pdf->SetFont('Arial','B',$fs[2]);
     $pdf->Cell($w[2],$h, $lang['Phone'],1,0,$al[2]);
     $pdf->SetFont('Arial','B',$fs[3]);
     $pdf->Cell($w[3],$h, $lang['AdrEmail'],1,0,$al[3]);
     $pdf->SetFont('Arial','B',$fs[4]);
     $pdf->Cell($w[4],$h, $lang['AdrFax'],1,0,$al[4]);
     $pdf->Ln();

     foreach ($this->obj->member as  $obj ) {
       $x = $obj->gettype();
       if ($x == "team") continue;

       $e = array();
       $f = array();
       $p = array();
       $d = array();
       $name = array();

       $name[] = $obj->getFullName();
       if ($x == "address") {
         $obj->read_locs_data();
         foreach($obj->location as $l) {
		   if (count($obj->location) == 1) {
		     $loc = "";
		   } else {
		     $loc = " (".$l->lname.")";
		   }
           if ($l->email_1)
             $e[] = $l->email_1 .$loc;
           if ($l->email_2)
             $e[] = $l->email_2 .$loc;
           if ($l->fax_1)
             $f[] = $l->fax_1 .$loc;
           if ($l->phone_1)
             $p[] = $l->phone_1 .$loc;
           if ($l->phone_2)
             $p[] = $l->phone_2 .$loc;
           if ($l->desc1)
             $d[] = $l->desc1 .$loc;
         }
       }
       if ($x == "team") {
         $name = array();
         $name[] = $lang[$x];
         $name[] = $obj->getFullName();
       }
       $max = 0;
       $max = max($max,count($name));
       $max = max($max,count($d));
       $max = max($max,count($e));
       $max = max($max,count($f));
       $max = max($max,count($p));

       for ($i=0;$i<$max;$i++) {
         $h = 5;
         $border = "LR";
         if ($i == 0) {
           $border .= "T";
           $h += 1;
         }
         if ($i == ($max-1)) {
           $border .= "B";
           $h += 1;
         }
         #name
         $pdf->SetFont('Arial','',$fs[0]);
         $pdf->Cell($w[0],$h, (isset($name[$i]) ? $name[$i]:" "),$border,0,$al[0]);
         #desc
         $pdf->SetFont('Arial','',$fs[1]);
         $pdf->Cell($w[1],$h, (isset($d[$i]) ? $d[$i]:" "),$border,0,$al[1]);
         #phone
         $pdf->SetFont('Arial','',$fs[2]);
         $pdf->Cell($w[2],$h,(isset($p[$i]) ? $p[$i] : " "),$border,0,$al[2]);
         #email
         $pdf->SetFont('Arial','',$fs[3]);
         $pdf->Cell($w[3],$h, (isset($e[$i]) ? $e[$i] : " "),$border,0,$al[3]);
         #fax
         $pdf->SetFont('Arial','',$fs[4]);
         $pdf->Cell($w[4],$h, (isset($f[$i]) ? $f[$i] : " "),$border,0,$al[4]);

         $pdf->Ln();
       }
     }

     $pdf->Close();
     $data = $pdf->buffer;
     Header("Content-Type: application/pdf");
     if(headers_sent()) {
       Fatal_Error('Some data has already been output to browser, can\'t send PDF file');
     }
     Header("Content-Disposition: inline; filename=\"". $this->obj->name .".pdf\"");
     Header("Content-Description: Upload from TUTOS" );
     Header('Content-Length: '.strlen($data));
     echo $data;
     return;
   }
   /**
    * the data display part
    */
   Function info() {
     global $lang;


     if ($this->format == 'pdf') {
       Header("Expires: 0");
       Header("Pragma: no-cache");
       $this->pdf();
       return;
     }

     echo $this->DataTableStart();
     echo "<tr>\n";
     echo " <th colspan=\"1\">". $lang['Team'] ." ".  myentities($this->obj->name) ."</th>\n";
     echo $this->user->layout->showGuiIcons("<th align=\"right\">","</th>",$this->obj,$this->obj,array("mod","del"),false);
     echo "</tr>\n";
     echo "<tr>\n";
     echo " <td>". $lang['TeamCreation'] ."</td>\n";
     echo " <td>". $this->obj->creation->getLinkDate() ."</td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfield($lang['TeamManager']);
     if (is_object($this->obj->owner)) {
       echo $this->showdata($this->obj->owner->getMailLink(),1);
     } else {
       echo $this->showdata("",1);
     }
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfield($lang['AdrEmail']);
     echo $this->showdata(AsEmail(myentities($this->obj->email),$this->obj->email,$this->obj->getFullName()),1);
     echo "</tr>\n";

     team::infolist($this->user,$this->obj,2,$this->format);

     echo "<tr>\n";
     echo " <th colspan=\"2\">". $lang['TeamMember'] ."(". count($this->obj->member) .")</th>\n";
     echo "</tr>\n";

     $line = 0;

     usort($this->obj->member,"member_sort");

     foreach ($this->obj->member as  $obj) {
       echo $this->OverviewRowStart($line);
       if ($obj->getType() == "team") {
         echo "<td colspan=\"2\">". $lang[$obj->getType()]." ".$obj->getLink() ."</td>\n";
       } else {
         echo "<td>". $obj->getLink() ."</td>\n";
         echo "<td>". AsEmail($obj->default_email(),$obj->default_email(),$obj->getFullName()) ."</td>\n";
       }
       echo $this->OverviewRowStart($line++);
     }	
	
     product::infolist($this->user,$this->obj,2,$this->format);
     show_module_infolists($this->user,$this->obj,2,$this->format);

     echo $this->obj->getHistoryLink(2);
     echo $this->DataTableEnd();
   }
   /**
    *
    */
   Function navigate() {
   }
   /**
    *
    */
   Function prepare() {
     global $tutos,$lang,$msg;

     $this->name = $lang['TeamDetail'];

     $this->obj = new team($this->dbconn);
     if ( isset ($_GET['id']) ) {
       $this->obj = $this->obj->read($_GET['id'],$this->obj);
     } else {
       $msg .= $lang['Err0048'] ."<br>";
       $this->stop = true;
     }
     if ( ! $this->obj->see_ok() ) {
       $msg .= sprintf($lang['Err0022'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else if ( $this->obj->id < 0 ) {
       $msg .= sprintf($lang['Err0040'],$lang[$this->obj->getType()]);
       $this->stop = true;
     } else {
       $this->name .= ": ".$this->obj->getFullName();
       $this->obj->read_member();
     }
     # menu
     $x = team::getSelectLink($this->user,$lang['Search']);
     $x[category][] = "obj";
     $this->addMenu($x);

     if ( $this->user->isAdmin() ) {
       $x = array( url => "team_new.php",
                   text => $lang['NewEntry'],
                   info => $lang['TeamCreateI'],
                   category => array("team","new","obj")
                 );
       $this->addMenu($x);
     }
     if ( ($this->obj->id > 0) && $this->obj->mod_ok() ) {
       $x = array( url => $this->obj->getModURL(),
                   text => $lang['Modify'],
                   info => sprintf($lang['TeamModifyI'],$this->obj->name),
                   category => array("team","new","obj")
                 );
       $this->addMenu($x);
     }
     
     if ($this->obj->id > 0) {
       $this->link1 = "team_show.php?id=".$this->obj->id;
       $l = addUrlParameter($this->link1,"format=paper");
       $x = array( url => $l,
                   text => $lang['Printable'],
                   info => $lang['PrintableInfo'],
                   category => array("view","team")
                 );

       $this->addMenu($x);       
       if ($tutos[fpdfpath] != "") {
         $l = addUrlParameter($this->link1,"format=pdf");
         $x = array( url => $l,
                     text => 'PDF',
                     info => 'PDF',
                     category => array("view","team")
                   );
         $this->addMenu($x);
       }
     }
     
     if ( ($this->obj->id > 0) && $this->user->feature_ok(usetimetrack,PERM_SEE) ) {
       $x = array( url => "timetrack_overview.php?worker=".$this->obj->id,
                   text => $lang['TimetrackBooked'],
                   info => sprintf($lang['TimetrackBookedI'],$this->obj->getFullName()),
                   category => array("timetrack","module")
                 );
       $this->addMenu($x);
     }
     if ( ($this->obj->id > 0) && $this->user->feature_ok(usetaskmanagement,PERM_SEE) ) {
       $x = array( url => "task_overview.php?id=".$this->obj->id,
                   text => $lang['TaskOverview'],
                   info => sprintf($lang['TaskOverviewInfo'],$this->obj->getFullName()),
                   category => array("task","module")
                 );
       $this->addMenu($x);
     }
     if ( ($this->obj->id > 0) 
          && $this->user->feature_ok(usetaskmanagement,PERM_SEE) 
          && $this->user->feature_ok(usetimetrack,PERM_SEE) 
          ) {
       $x = array( url => "res_cal.php?id=".$this->obj->id,
                   text => $lang['ResCal'],
                   info => $lang['ResCal'],
                   category => array("timetrack","task","module")
                 );
       $this->addMenu($x);
     }
     if ( $this->obj->id > 0) {
       $x = $this->obj->getMailLink($this->user);
       $this->addMenu($x);
     }
     if ( ($this->obj->id > 0) && $this->user->feature_ok(usecalendar,PERM_SEE) ) {
       $x = $this->obj->getCalLink($this->user);
       $this->addMenu($x);
     }

     add_module_addlinks($this,$this->obj);

     # add this page to the browsehistory of the users session
     $this->addtohistory();
     web_StackStartLayoutObj($this);
   }
 }

 $l = new team_show($current_user);
 $l->display();
 $dbconn->Close();
?>